代码随想录训练营第十七天|LeetCode 110、257、404

LeetCode 110平衡二叉树

题目链接:110.平衡二叉树

//自己写的递归
class Solution {
public:
    int getDepth(TreeNode* node) {
        if (node == nullptr) return 0;
        return max(getDepth(node->left), getDepth(node->right)) + 1;
    }
    bool isBalanced(TreeNode* root) {
        if (root == nullptr) return true;
        return (isBalanced(root->left) && isBalanced(root->right) && abs(getDepth(root->left) - getDepth(root->right)) < 2);
    }
};
//递归
class Solution {
public:
    //既要考虑当前子树是否平衡,也要将高度作为参考值看更大的子树是否平衡
    int getHeight(TreeNode* node) {
        if (node == nullptr) return 0;
        //如果当前传入节点为根节点的二叉树已经不是二叉平衡树了,还返回高度的话就没有意义了
        //所以如果已经不是二叉平衡树了,直接返回-1来标记!
        int leftHeight = getHeight(node->left);
        if (leftHeight == -1) return -1;
        int rightHeight = getHeight(node->right);
        if (rightHeight == -1) return -1;
        return abs(leftHeight - rightHeight) > 1 ? -1 : max(leftHeight, rightHeight) + 1;
    }
    bool isBalanced(TreeNode* root) {
        return getHeight(root) == -1 ? false : true;
    }
};

LeetCode 257二叉树的所有路径

题目链接:257.二叉树的所有路径

//回溯
class Solution {
public:
    vector<string> result;
    string path;
    void backtracking(TreeNode* node, string path) {//注意这里path不能是引用类型
        path += to_string(node->val);
        if (!node->left && !node->right) {
            result.push_back(path);
            return;
        }
        if (node->left) {
            backtracking(node->left, path + "->");
        }
        if (node->right) {
            backtracking(node->right, path + "->");
        }
    }
    vector<string> binaryTreePaths(TreeNode* root) {
        result.clear();
        path.clear();
        backtracking(root, path);
        return result;
    }
};
//迭代:前序遍历
class Solution {
public:
    vector<string> binaryTreePaths(TreeNode* root) {
        vector<string> ans;
        stack<TreeNode*> treeSt;
        stack<string> pathSt;
        if (root == nullptr) return ans;
        treeSt.push(root);
        pathSt.push(to_string(root->val));
        while (!treeSt.empty()) {
            TreeNode* cur = treeSt.top(); treeSt.pop();
            string path = pathSt.top(); pathSt.pop();
            if (!cur->left && !cur->right) {
                ans.push_back(path);
            }
            if (cur->right) {
                treeSt.push(cur->right);
                pathSt.push(path + "->" + to_string(cur->right->val));
            }
            if (cur->left) {
                treeSt.push(cur->left);
                pathSt.push(path + "->" + to_string(cur->left->val));
            }
        }
        return ans;
    }
};

LeetCode 404左叶子之和

题目链接:404.左叶子之和

//递归
class Solution {
public:
    int sumOfLeftLeaves(TreeNode* root) {
        int sum = 0;
        if (root == nullptr) return sum;
        sum += sumOfLeftLeaves(root->left) + sumOfLeftLeaves(root->right);
        if (root->left && !root->left->left && !root->left->right) sum += root->left->val;
        return sum;
    }
};
//迭代
class Solution {
public:
    int sumOfLeftLeaves(TreeNode* root) {
        int sum = 0;
        if (root == nullptr) return sum;
        stack<TreeNode*> st;
        st.push(root);
        while (!st.empty()) {
            TreeNode* cur = st.top(); st.pop();
            if (cur->left && !cur->left->left && !cur->left->right) sum += cur->left->val;
            if (cur->right) st.push(cur->right);
            if (cur->left) st.push(cur->left);
        }
        return sum;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值